# In constraint negation issue reproducer

This reproducer shows that it is not possible to compile patterns of the form:

    Pojo(!(x in (1,2,3)))
    
because the ```KieBuilder``` fails with the following error:

    Error Messages:
    Message [id=1, kieBase=defaultKieBase, level=ERROR, path=rules.drl, line=4, column=0
       text=Unable to Analyse Expression !(x in (1,2,3)):
    [Error: unexpected token: ,2]
    [Near : {... !(x in (1,2,3)) ....}]
                          ^
Furthermore, as of Drools 7.29.0.Final, the following form will also fail to compile:

    forall(Pojo(y==42, x in (1,2,3)))
    
with the following error:

    Error Messages:
    Message [id=1, kieBase=defaultKieBase, level=ERROR, path=rules.drl, line=4, column=0
       text=Unable to Analyse Expression !(y==42) || !(x in (1,2,3)):
    [Error: unexpected token: ,2]
    [Near : {... !(y==42) || !(x in (1,2,3)) ....}]
                                      ^
This is likely a consequence of the negation introduced by [DROOLS-4632](https://issues.redhat.com/browse/DROOLS-4632).

## How to reproduce

    mvn clean test